;-----------------------------------------------------------------------
;
;	       Pro Turbo Cruncher v3.0
;     	    	    Decompressor
;
; HL -    
; DE -   
;
;-----------------------------------------------------------------------

Depack:			
		LD   A,(HL)		; A' = (HL)			;     
		EX   AF,AF'		; 
		LD   B,0		; B =  0
		LD   IX,DECO		; IX = DECO			;    
		CALL DECO-1		; ==> DECO-1			;   
		
		EX   AF,AF'		; 
		LD   (DE),A		; (DE) = A'			;   
		RET			; 
	
;-----------------------------------------------------------------------	
M5:
		RLCA			; C<-A-<			;  A ,    
		JR   C,M6		;  C = 1,  --> 6		; 
		
;----------------------------------------------------------------------- : LZ,  0..8191,  0..255
									
		LD   A,(HL)		; A = (HL)			;      
		AND  $1F		; A = A and $1F			;
		LD   B,A		; B = A				; B = 0..31 (  )
		INC  HL			; HL = HL + 1			;    
		LD   C,(HL)		; C = (HL)			;     (C -  0..255)
		JR   IYP		; --> IYP			; -->   
		
;----------------------------------------------------------------------- : LZ,  2048..3071,  3..10
M6:
		AND  $C2		; A = A and 0xC2		;   2 
									;  1  1
							
		JR   M7			; --> M7			; -->    

;-----------------------------------------------------------------------	
LZMET:
		RLCA			; C<-A-<			;  A ,    
		JR   C,M5		;  C = 1,  --> 5		; 
		
;----------------------------------------------------------------------- : LZ,  0..2047,  3..10
									
		AND  $E0		; A = A and 0xE0		;   A  3  
		RLCA			; C<-A-<			;  A ,    
	
M7:		RLCA			; C<-A-<			;  A ,    
		RLCA			; C<-A-<			;  A ,    
		LD   B,A		; B = A				; B -    (2  3 )
		LD   A,(HL)		;  = (HL)			;      
		AND  7			; A = A and 7			;   A  3 
		ADD  A,2		; A = A + 2			;
		LD   C,A		; C = A				; C - 2..9 (  )
IYP:	
		INC  HL			; HL = HL + 1			;    
		PUSH HL			;  HL
		LD   A,E		; A = E				; HL = DE - B.m(HL)
		SUB  (HL)		; A = A - (HL)			;
		LD   L,A		; L = A				;
		LD   A,D		; A = D				;
		SBC  A,B		; A = A - B - c			;
		LD   H,A		; H = A				;
		LD   B,0		; B = 0				;
	
DACO:		LDIR			; (HL)->(DE), len BC		;    (HL)  (DE)
		POP  HL			;  HL		;
					;				; --> 
		INC  HL			; HL = HL + 1 			;     
	
;-----------------------------------------------------------------------   
									
DECO:		LD   A,(HL)		; A = (HL) 			;    
		RLCA			; C<--<			;  A ,  7-   
		JR   C,LZMET		;  C = 1,  --> LZNET	; --> LZ-
		
;----------------------------------------------------------------------- Copy/Fill-
		
		RLCA			; C<--<			;  A ,  6-   
		JR   C,FillZone		;  C = 1,  --> FillZone	; --> Fill-

;-----------------------------------------------------------------------     1..64
																
		LD   C,(HL)		; C = (HL)			;       ( )
		INC  C			; C = C + 1			;   1..64
		INC  HL			; HL = HL + 1			;    
		LDIR			; (HL)->(DE), len BC		;  C   (HL)  (DE)
		JP   (IX)		; --> DECO			;   --> DECO
		
;----------------------------------------------------------------------- 		

FillZone:	RLCA			; C<--<			;  A ,  5-   
		LD   A,(HL)		; A = (HL)			;      
		JR   C,FillLong		;  C = 1,  --> FillLong	; --> FillLong

;----------------------------------------------------------------------- Fill- 

		AND  $1F		; A = A and #1F			;   5 
		RET  Z			;  = 0,   -->	;   ,   -->
		LD   C,A		; C = A				; C   1..31 
		
;-----------------------------------------------------------------------	
M3:		
		INC  HL			; HL = HL + 1			;    
		PUSH HL			;  HL
		LD   A,(HL)		; A = (HL)			;    
		LD   H,D		; H = D
		LD   L,E		; L = E				; HL =  
		INC  DE			; DE = DE + 1			; DE =   + 1
		LD   (HL),A		; (HL) = A			;      (HL)
		JR   DACO		; --> DACO			;  

;----------------------------------------------------------------------- :  1..8191	
FillLong:
		AND  $1F		; A = A and #1F			;   5 
		LD   B,A		; B = A				; B   0..31 (B -   )
		INC  HL			; HL = HL + 1			;    
		LD   C,(HL)		; C = (HL)			;     (C -   )
		JR   M3			; --> M3			; -->  
		
;=======================================================================	